using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;
using mshtml;

namespace PrivacyGuard
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class IEBrowser : System.Windows.Forms.Form
	{
		public const bool WEBWALLETSTUDY = true;
		public const string LOGINPASSWORD = "johnny1";

		public const int MAXIMIZEDX = 1024;
		public const int WEBWALLETW = 250;
		public const int WEBWALLETH = 626;
		
		public const int BROWSINGH = 626;
		public const int BROWSINGY = 91;
		public const int BROWSINGHWITHWARNING = 596;
		public const int BROWSINGYWITHWARNING = 121;
		//		private int browsingHless = 606;
		//		private int browsingYless = 111;
		//		private int browsingHleast = 581;
		//		private int browsingYleast = 136;

		public const int BORDER = 3;

		private int f2keycounter = 0;

		private string[] legalsites = 
			new string[]{"ae.com", "amazon.com", "apple.com", "bestbuy.com",
								"bloomingdales.com",
							   "buy.com", "compusa.com", "deepdiscountdvd.com", 
								"dvdplanet.com", "ebgames.com",
							   "hsn.com", "kbtoys.com", 
								"kmart.com", "macys.com", 
								"pcconnection.com", "radioshack.com",
								"staples.com", "target.com", "travelocity.com",
							   "yahoo.com", "google.com"};

		private AxSHDocVw.AxWebBrowser browsingWindow;

		private IEBrowserToolkit.Menubar menuBar;
		private IEBrowserToolkit.Toolbar toolBar;
		private IEBrowserToolkit.Addressbar addressBar;
		private IEBrowserSecurityToolkit.Warningbar warningBar;
		public IEBrowserSecurityToolkit.Warningbar WarningBar 
		{
			get 
			{
				return this.warningBar;
			}
		}
		private WebWallet.InlineProtectionToolkit.Reminderbar reminderBar;
		public WebWallet.InlineProtectionToolkit.Reminderbar ReminderBar 
		{
			get 
			{
				return this.reminderBar;
			}
		}
		private IEBrowserToolkit.Statusbar statusBar;

		private IEBrowserToolkit.BrowsingPanel browsingPanel;
		public IEBrowserToolkit.BrowsingPanel BrowsingPanel 
		{
			get 
			{
				return this.browsingPanel;
			}
		}

		private System.Windows.Forms.PictureBox small_sep1;
		private System.Windows.Forms.PictureBox small_sep2;
		private string smallsep_image = @"C:\VisualStudio\PrivacyGuard\images\small_seperator.png";
		private System.Windows.Forms.PictureBox big_sep1;
		private System.Windows.Forms.PictureBox big_sep2;
		private string bigsep_image = @"C:\VisualStudio\PrivacyGuard\images\big_seperator.png";

		private WebWallet.WebWalletInterface webwallet;
		public WebWallet.WebWalletInterface Webwallet 
		{
			get 
			{
				return this.webwallet;
			}
		}

		// const browsing values
		static public Object nobj = System.Reflection.Missing.Value;
		//public const string HOME_URI = @"http://www.google.com/";
		public const string TUTOR_URI = @"C:\VisualStudio\PrivacyGuard\emails\webwallet_tutorial.html";
		public const string TUTOR_SUFFIX = "webwallet_tutorial.html";

		// support IEExt
		private int dwCookie;
		static public int dwCookie2;

		// annotation layer
		private PrivacyGuard.AnnotationLayer annotationLayer;
		public PrivacyGuard.AnnotationLayer AnnotationLayer 
		{
			get 
			{
				return annotationLayer;
			}
		}

		// inline protection
		private PrivacyGuard.WebWallet.InlineProtectionToolkit.ProtectedGroup protectedGroup;
		public PrivacyGuard.WebWallet.InlineProtectionToolkit.ProtectedGroup ProtectedGroup 
		{
			get 
			{
				return this.protectedGroup;
			}
		}

		// independent confirmation
//		private PrivacyGuard.ConfirmationToolkit.ConfirmationTrigger confirmationTrigger;
//		public PrivacyGuard.ConfirmationToolkit.ConfirmationTrigger ConfirmationTrigger 
//		{
//			get 
//			{
//				return this.confirmationTrigger;
//			}
//		}

		// Backend Implementation
		private BackEndImpl.History history;
		public BackEndImpl.History History 
		{
			get 
			{
				return this.history;
			}
		}
		private BackEndImpl.SecureStorage secureStorage;
		public BackEndImpl.SecureStorage SecureStorage 
		{
			get 
			{
				return this.secureStorage;
			}
		}
		private BackEndImpl.ReputationEvaluator reputationEvaluator;
		public BackEndImpl.ReputationEvaluator ReputationEvaluator 
		{
			get 
			{
				return this.reputationEvaluator;
			}
		}
		private BackEndImpl.WebpageAnalyzer webpageAnalyzer;
		public BackEndImpl.WebpageAnalyzer WebpageAnalyzer 
		{
			get 
			{
				return this.webpageAnalyzer;
			}
		}

		private System.Windows.Forms.Timer warningTimer;
		public System.Windows.Forms.Timer WarningTimer 
		{
			get 
			{
				return this.warningTimer;
			}
		}

//		private bool trustedSite = false;
//		public bool TrustedSite 
//		{
//			get 
//			{
//				return this.trustedSite;
//			}
//		}

		//**********************
		// user study related interface
		//
		private UserStudyToolkit.EmailInbox inbox;
		private bool localize;
		public bool Localize 
		{
			get 
			{
				return this.localize;
			}
		}

		// simulated phishing part
		private PhishingAttacks.PhishingMonitor phishingmonitor;
		public PhishingAttacks.PhishingMonitor Phishingmonitor 
		{
			get 
			{
				return this.phishingmonitor;
			}
		}
		//
		//**********************

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public IEBrowser()
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.history = new PrivacyGuard.BackEndImpl.History();
				this.reputationEvaluator = new PrivacyGuard.BackEndImpl.ReputationEvaluator();
			}

			this.secureStorage = new PrivacyGuard.BackEndImpl.SecureStorage();
			this.webpageAnalyzer = new PrivacyGuard.BackEndImpl.WebpageAnalyzer();
			// phishing part
			this.phishingmonitor = new PrivacyGuard.PhishingAttacks.PhishingMonitor(this);

			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.annotationLayer = new AnnotationLayer();
				this.annotationLayer.Show();
			}

			PrivacyGuard.IEBrowserSecurityExt.IEEvents ieevt;
			ieevt = new PrivacyGuard.IEBrowserSecurityExt.IEEvents(this);

			// using the phishing-enabled protected group
			//			this.protectedGroup = 
			//				new WebWallet.InlineProtectionToolkit.ProtectedGroup(this);
			this.protectedGroup = 
				new PhishingAttacks.ProtectedGroup(this);

//			this.confirmationTrigger = 
//				new ConfirmationToolkit.ConfirmationTrigger();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(IEBrowser));
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();

			this.browsingWindow = new AxSHDocVw.AxWebBrowser();

			this.components = new System.ComponentModel.Container();

			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.warningTimer = new System.Windows.Forms.Timer(this.components);
				this.warningTimer.Enabled = true;
				this.warningTimer.Tick += new EventHandler(warningTimer_Tick);
			}

			((System.ComponentModel.ISupportInitialize)(this.browsingWindow)).BeginInit();
			this.SuspendLayout();

			//
			// menubar
			//
			this.menuBar = new PrivacyGuard.IEBrowserToolkit.Menubar();
			this.menuBar.Location = new Point(0, 0);
			//
			// toolbar
			//
			this.toolBar = new PrivacyGuard.IEBrowserToolkit.Toolbar(this);
			this.toolBar.Location = new Point(0, 24);
			//
			// small separator
			//
			this.small_sep1 = new PictureBox();
			this.small_sep1.Location = new Point(0, 62);
			this.small_sep1.Size = new Size(MAXIMIZEDX, 2);
			this.small_sep1.Image = Image.FromFile(smallsep_image);
			//
			// addressbar
			//
			// using the phishing addressbar
			//this.addressBar = new PrivacyGuard.IEBrowserToolkit.Addressbar(this);
			this.addressBar = new PhishingAttacks.Addressbar(this);
			this.addressBar.Location = new Point(0, 64);
			//
			// small separator
			//
			this.small_sep2 = new PictureBox();
			this.small_sep2.Location = new Point(0, 86);
			this.small_sep2.Size = new Size(MAXIMIZEDX, 2);
			this.small_sep2.Image = Image.FromFile(smallsep_image);

			if (IEBrowser.WEBWALLETSTUDY) 
			{
				//
				// warning bar
				//
				this.warningBar = new PrivacyGuard.IEBrowserSecurityToolkit.Warningbar(this);
				//
				// reminder bar
				//
				this.reminderBar = new PrivacyGuard.WebWallet.InlineProtectionToolkit.Reminderbar(88);
				this.reminderBar.Location = new Point(0, this.reminderBar.HidePositionY);
			}
			//
			// big separator
			//
//			startY += IEBrowserSecurityToolkit.Warningbar.FIXEDY;
			this.big_sep1 = new PictureBox();
			this.big_sep1.Location = new Point(0, 88);
			this.big_sep1.Size = new Size(MAXIMIZEDX, 3);
			this.big_sep1.Image = Image.FromFile(bigsep_image);

			if (IEBrowser.WEBWALLETSTUDY) 
			{
				// 
				// browsingWindow
				//
				// using the phishing-enabled browsing panel
				//this.browsingPanel = new IEBrowserToolkit.BrowsingPanel(this);
				this.browsingPanel = new PhishingAttacks.BrowsingPanel(this);

				this.browsingWindow.AllowDrop = ((bool)(configurationAppSettings.GetValue("browsingWindow.AllowDrop", typeof(bool))));
				this.browsingWindow.Enabled = true;
				this.browsingWindow.Location = new System.Drawing.Point(IEBrowser.BORDER, IEBrowser.BORDER);
				this.browsingWindow.Size = new System.Drawing.Size(this.Width - 2*IEBrowser.BORDER, this.Height - 2*IEBrowser.BORDER);
				this.browsingWindow.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
				this.browsingWindow.BeforeNavigate2 += new AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2EventHandler(browsingWindow_BeforeNavigate2);
				this.browsingWindow.DocumentComplete += new AxSHDocVw.DWebBrowserEvents2_DocumentCompleteEventHandler(browsingWindow_DocumentComplete);
				//			this.browsingWindow.TitleChange += new AxSHDocVw.DWebBrowserEvents2_TitleChangeEventHandler(browsingWindow_TitleChange);
				this.browsingWindow.Resize += new EventHandler(browsingWindow_Resize);

				this.browsingPanel.Controls.Add(this.browsingWindow);
				this.browsingPanel.SetBrowsingWindow(this.browsingWindow);
				//this.browsingPanel.UpdateDisplay(true);
			} 
			else 
			{
				this.browsingWindow.AllowDrop = ((bool)(configurationAppSettings.GetValue("browsingWindow.AllowDrop", typeof(bool))));
				this.browsingWindow.Enabled = true;
				this.browsingWindow.Location = new System.Drawing.Point(0, IEBrowser.BROWSINGY);
				this.browsingWindow.Size = new System.Drawing.Size(IEBrowser.MAXIMIZEDX, IEBrowser.BROWSINGH);
				this.browsingWindow.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser1.OcxState")));
				this.browsingWindow.BeforeNavigate2 += new AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2EventHandler(browsingWindow_BeforeNavigate2);
				this.browsingWindow.DocumentComplete += new AxSHDocVw.DWebBrowserEvents2_DocumentCompleteEventHandler(browsingWindow_DocumentComplete);
			}

			//
			// big separator
			//
			this.big_sep2 = new PictureBox();
			this.big_sep2.Location = new Point(0, 717);
			this.big_sep2.Size = new Size(MAXIMIZEDX, 3);
			this.big_sep2.Image = Image.FromFile(bigsep_image);
			//
			// statusbar
			//
			this.statusBar = new PrivacyGuard.IEBrowserToolkit.Statusbar();
			this.statusBar.Location = new Point(0, 720);
			//
			// webwallet
			//
			//this.webwallet = new PrivacyGuard.WebWallet.WebWalletInterface();
			// 
			// IEBrowser
			// 

			//
			// inbox
			//
			this.inbox = new PrivacyGuard.UserStudyToolkit.EmailInbox(this);
			this.inbox.Location = new Point(0, 91);
			this.inbox.Hide();

			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(1016, 734);
			this.Controls.Add(this.menuBar);
			this.Controls.Add(this.toolBar);
			this.Controls.Add(this.small_sep1);
			this.Controls.Add(this.addressBar);
			this.Controls.Add(this.small_sep2);
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.Controls.Add(this.reminderBar);
				this.Controls.Add(this.warningBar);
			}
			this.Controls.Add(this.big_sep1);
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.Controls.Add(this.browsingPanel);
			} 
			else 
			{
				this.Controls.Add(this.browsingWindow);
			}
			//this.Controls.Add(this.webwallet);
			this.Controls.Add(this.big_sep2);
			this.Controls.Add(this.statusBar);
			
			this.Controls.Add(this.inbox);

			this.Name = "IEBrowser";
			this.Text = "Microsoft Internet Explorer";
			this.WindowState = System.Windows.Forms.FormWindowState.Maximized;
			((System.ComponentModel.ISupportInitialize)(this.browsingWindow)).EndInit();
			this.ResumeLayout(false);

			this.Load += new EventHandler(IEBrowser_Load);
			this.Closing += new CancelEventHandler(IEBrowser_Closing);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new IEBrowser());
		}

		private void IEBrowser_Load(object sender, System.EventArgs e) 
		{
			//this.browsingWindow.Navigate(HOME_URI, ref nobj, ref nobj, ref nobj, ref nobj);
			this.GoHome();
		}

		private void IEBrowser_Closing(object sender, System.ComponentModel.CancelEventArgs e) 
		{
			//axWebBrowser1 represents the web browser control
			//get the IConnectionPointContainer interface of web browser control
			UCOMIConnectionPointContainer pConPtCon =
				(UCOMIConnectionPointContainer)this.browsingWindow.GetOcx();
			UCOMIConnectionPoint pConPt;
			//get IID of DWebBrowserEvents2
			Guid guid = typeof(SHDocVw.DWebBrowserEvents2).GUID;
			//find the IConnectionPoint interface corresponding to GUID
			pConPtCon.FindConnectionPoint(ref guid, out pConPt);
			//disconnect sink object from Web browser
			pConPt.Unadvise(dwCookie);

			mshtml.HTMLDocument doc =
				(mshtml.HTMLDocument)this.browsingWindow.Document;
			pConPtCon = (UCOMIConnectionPointContainer)doc;
			guid = typeof(mshtml.HTMLDocumentEvents2).GUID;
			pConPtCon.FindConnectionPoint(ref guid, out pConPt);
			pConPt.Unadvise(dwCookie2);
		}

		// browsing window events:
		// - BeforeNavigate2
		// - DocumentComplete
		// - TitleChange
		private void browsingWindow_BeforeNavigate2(object sender, AxSHDocVw.DWebBrowserEvents2_BeforeNavigate2Event e) 
		{
			if (!IsLegalUrl(e.uRL.ToString()))
				return;
			string goingurl = e.uRL.ToString();
			if (!this.IsTutorUrl(goingurl))
				this.LocalizeBrowser(IsLocalUrl(goingurl));
			ProcessingUrl(goingurl);

//			PhishingAttacks.PhishingConfig.ATTACKTYPE at
//				= this.phishingmonitor.GetPhishingType(this.GetDomainName(true));

//			if (at != PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKEWW)	
//			{
//				if ((this.browsingPanel as PhishingAttacks.BrowsingPanel).ContainsFakeWebWallet()) 
//				{
//					(this.browsingPanel as PhishingAttacks.BrowsingPanel).RemoveWebWallet();
//					this.browsingPanel.UpdateDisplay(true);
//				}
//			}
//			if ((at != PhishingAttacks.PhishingConfig.ATTACKTYPE.IMAGEMAP)) 
//			{
//				if ((this.browsingPanel as PhishingAttacks.BrowsingPanel).ContainsOnlineKeyBoard()) 
//				{
//					(this.browsingPanel as PhishingAttacks.BrowsingPanel).RemoveOnlineKeyBoard();
//					this.browsingPanel.UpdateDisplay(true);
//				}
//			}
		}
		private void browsingWindow_DocumentComplete(object sender, AxSHDocVw.DWebBrowserEvents2_DocumentCompleteEvent e) 
		{
			if (!IsLegalUrl(e.uRL.ToString()))
				return;
			string goingurl = e.uRL.ToString();
			//this.LocalizeBrowser(IsLocalUrl(goingurl));
			ProcessingUrl(goingurl);
			if (IsLocalUrl(goingurl) && !this.IsTutorUrl(goingurl)) 
			{
				this.LocalizeBrowser(IsLocalUrl(goingurl));
				return;
			}

			if (IEBrowser.WEBWALLETSTUDY) 
			{
				if (this.webwallet == null) 
				{
					this.webwallet = new PrivacyGuard.WebWallet.WebWalletInterface(this);
					this.Controls.Add(this.webwallet);
					this.webwallet.Hide();
				}
			
				// TODO: DANGER! Here is a security hole. 
				// In this prototype, the inline annotation will be added after the page is completely loaded.
				// The attacker can bypass it by make his page hard to completely load while at the same time
				// the form asking for sensitive information is ready to use.
				// PROPOSED SOLUTION: 
				// Periodically update online annotation when the page is loaded.
				this.protectedGroup.ResetProtectedGroup();
				IHTMLDocument2 doc = this.browsingWindow.Document as IHTMLDocument2;
				this.protectedGroup.FormProtectedGroup(doc, this.webwallet.Visible);
			
				PhishingAttacks.PhishingConfig.ATTACKTYPE at
					= this.phishingmonitor.GetPhishingType(this.GetDomainName(true));

				if (at == PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKEWW)				
				{
					if (this.protectedGroup.GetFocusedRequest() != null) 
					{
						(this.browsingPanel as PhishingAttacks.BrowsingPanel).AddWebWallet();
						this.browsingPanel.UpdateDisplay(true);
					} 
					else 
					{
						if ((this.browsingPanel as PhishingAttacks.BrowsingPanel).ContainsFakeWebWallet()) 
						{
							(this.browsingPanel as PhishingAttacks.BrowsingPanel).RemoveWebWallet();
							this.browsingPanel.UpdateDisplay(true);
						}
					}
				} 
			
				if ((at == PhishingAttacks.PhishingConfig.ATTACKTYPE.IMAGEMAP)) 
				{
					if ((this.protectedGroup as PhishingAttacks.ProtectedGroup).PasswordInput != null) 
					{
						(this.browsingPanel as PhishingAttacks.BrowsingPanel).AddOnlineKeyBoard((this.protectedGroup as PhishingAttacks.ProtectedGroup).PasswordInput);
						this.browsingPanel.UpdateDisplay(true);
					} 
					else 
					{
						if ((this.browsingPanel as PhishingAttacks.BrowsingPanel).ContainsOnlineKeyBoard()) 
						{
							(this.browsingPanel as PhishingAttacks.BrowsingPanel).RemoveOnlineKeyBoard();
							this.browsingPanel.UpdateDisplay(true);
						}
					}
				} 

				if ((at == PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKESUG)) 
				{
					//				if (!this.phishingmonitor.AcknowledgeIP) 
					//				{
					//					PhishingAttacks.StopDialog dlg = new PrivacyGuard.PhishingAttacks.StopDialog(this);
					//					dlg.ShowDialog();
					//				}
					if (!this.phishingmonitor.AcknowledgeIP) 
					{
						PhishingAttacks.SuggestionForm sug = new PrivacyGuard.PhishingAttacks.SuggestionForm(this);
						sug.ShowDialog();
					}
				}

				if (this.protectedGroup.GetFocusedRequest() == null)
					this.HideWebWallet();
				this.webwallet.UpdateDisplay();
			}
			else 
			{
				this.protectedGroup.ResetProtectedGroup();
				IHTMLDocument2 doc = this.browsingWindow.Document as IHTMLDocument2;
				this.protectedGroup.FormProtectedGroup(doc, false);
			}
		}
//		private void browsingWindow_TitleChange(object sender, AxSHDocVw.DWebBrowserEvents2_TitleChangeEvent e) 
//		{
//			ProcessingUrl(this.browsingWindow.LocationURL);
//		}
		private void browsingWindow_Resize(object sender, System.EventArgs e) 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				if (this.protectedGroup != null)
					this.protectedGroup.UpdateHighlight(this.browsingWindow.Document as IHTMLDocument2);
			}
		}
		private void ProcessingUrl(string url) 
		{
			this.addressBar.UpdateUrl(url);
			//ShowWarningbar();
//			this.trustedSite = this.reputationEvaluator.IsTrustedSite(PrivacyGuardUtils.IEUtil.GetDomainName(url));
//			if (this.trustedSite)
//			{
//				HideWarningbar();
//			} 
//			else 
//			{
//				ShowWarningbar();
//			}
		}
		public void GotoSafePath(string domain, bool noattack) 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				if (noattack) 
					this.phishingmonitor.RemoveAttack(domain);
				string url = PrivacyGuardUtils.IEUtil.GetUrl(domain);
				this.browsingWindow.Navigate(url, ref nobj, ref nobj, ref nobj, ref nobj);
			}
		}
		public void GoHome() 
		{
			//this.browsingWindow.Navigate(IEBrowser.HOME_URI, ref nobj, ref nobj, ref nobj, ref nobj);
			//this.GotoUrl(IEBrowser.HOME_URI);
			this.LocalizeBrowser(true);
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				(this.browsingPanel as PhishingAttacks.BrowsingPanel).RemoveWebWallet();
				(this.browsingPanel as PhishingAttacks.BrowsingPanel).RemoveOnlineKeyBoard();
			}
		}
		public void GotoUrl(string url) 
		{
			this.browsingWindow.Navigate(url, ref nobj, ref nobj, ref nobj, ref nobj);
		}
		public void GotoGooglesearch(string search) 
		{
			string searchterm = search.Replace(" ", "+");
			string searchurl = @"http://www.google.com/search?hl=en&q=" + searchterm;
			this.GotoUrl(searchurl);
		}
		public void GotoTutorial() 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.GotoUrl(IEBrowser.TUTOR_URI);
			}
		}
		private void warningTimer_Tick(object sender, System.EventArgs e) 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.warningBar.UpdateHighlight();
			}
		}

		protected override bool ProcessCmdKey(ref Message msg, Keys keyData) 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.f2keycounter++;
				if (this.f2keycounter%2 == 1) 
				{
					if (!this.inbox.Visible) 
					{
						if (keyData == Keys.F2) 
						{
							if (this.webwallet == null) 
							{
								this.webwallet = new PrivacyGuard.WebWallet.WebWalletInterface(this);
								this.Controls.Add(this.webwallet);
								this.webwallet.Hide();
							}

							if (!this.webwallet.Visible) 
							{
								ShowWebWallet();
							} 
							else 
							{
								HideWebWallet();
							}
						}
					}
				}
			}
			return base.ProcessCmdKey (ref msg, keyData);
		}

		public void WebWalletClose() 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.HideWebWallet();
			}
		}

		private void ShowWebWallet() 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.warningBar.Hide();
				this.browsingPanel.Location = new Point(0, BROWSINGY);
				this.browsingPanel.Size = new Size(MAXIMIZEDX-WEBWALLETW, IEBrowser.BROWSINGH);
				this.browsingPanel.UpdateDisplay(true);
				this.webwallet.Show();
				this.protectedGroup.ForceHighlight(true);
				this.webwallet.Submit();
			}
		}

		private void HideWebWallet() 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				this.warningBar.Show();
				this.browsingPanel.Location = new Point(0, IEBrowser.BROWSINGYWITHWARNING);
				this.browsingPanel.Size = 
					new Size(MAXIMIZEDX, IEBrowser.BROWSINGHWITHWARNING);
				this.browsingPanel.UpdateDisplay(true);

				this.webwallet.Hide();
				if (this.phishingmonitor.GetPhishingType(this.GetDomainName(true))
					!= PhishingAttacks.PhishingConfig.ATTACKTYPE.FAKEWW)
					this.protectedGroup.ForceHighlight(false);
			}
		}

//		private void ShowWarningbar() 
//		{
//			this.warningBar.Show();
//		}
//
//		private void HideWarningbar () 
//		{
//			this.warningBar.Hide();
//		}

		// browser-related functions
		// 1. GetBrowsingWindow
		// 2. GetDocument
		// 3. GetProtocol
		// 4. GetDomainName
		public AxSHDocVw.AxWebBrowser GetBrowsingWindow() 
		{
			return this.browsingWindow;
		}
		public IHTMLDocument2 GetDocument() 
		{
			return (IHTMLDocument2) this.browsingWindow.Document;
		}
		public string GetProtocol(bool authentic) 
		{
			if (authentic) 
			{
				// return the real connection parameters
				IHTMLDocument2 doc = this.GetDocument();
				if (doc != null) 
					return this.GetDocument().protocol;
				else 
					return null;
			}	 
			else 
			{
				// return the simulated phishing parameters
				// which should be processed based on the address bar display
				return this.addressBar.GetProtocol();
			}
		}
		public string GetDomainName(bool authentic) 
		{
			if (authentic) 
			{
				//string url = this.browsingWindow.LocationURL;
				string url = (this.browsingWindow.Document as IHTMLDocument2).url;
				return PrivacyGuard.PrivacyGuardUtils.IEUtil.GetDomainName(url);
			} 
			else 
				return this.addressBar.GetDomainName();
			
		}

		public string GetDomainDescription(string domain) 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				return this.reputationEvaluator.GetDomainDescription(domain);
			} 
			else 
			{
				return null;
			}
		}
		private void LocalizeBrowser(bool b) 
		{
			if (this.localize == b)
				return;

			localize = b;
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				if (b) 
				{
					this.inbox.Show();
					this.warningBar.Hide();
					if (this.webwallet != null)
						this.webwallet.Hide();
					this.browsingPanel.Location = new Point(0, BROWSINGY+this.inbox.Height);
					this.browsingPanel.Size = new Size(MAXIMIZEDX, IEBrowser.BROWSINGH-this.inbox.Height);
					this.browsingPanel.UpdateDisplay(false);
					//				this.browsingWindow.Location = new Point(0, 0);
					//				this.browsingWindow.Size = this.browsingPanel.Size;
					this.inbox.GotoCurrentEmail();
				} 
				else 
				{
					(this.browsingWindow.Document as IHTMLDocument2).write("<html><body></body></html>");
					this.inbox.Hide();
					this.warningBar.Show();
					if (this.webwallet != null)
						this.webwallet.Hide();
					this.browsingPanel.Location = new Point(0, IEBrowser.BROWSINGYWITHWARNING);
					this.browsingPanel.Size = new Size(MAXIMIZEDX, IEBrowser.BROWSINGHWITHWARNING);
					this.browsingPanel.UpdateDisplay(true);
					//				this.browsingWindow.Location = new Point(BORDER, BORDER);
					//				this.browsingWindow.Size = new System.Drawing.Size(this.browsingPanel.Width - 2*BORDER, this.browsingPanel.Height - 2*BORDER);
				}
			} 
			else 
			{
				if (b) 
				{
					this.inbox.Show();
					this.browsingWindow.Location = new Point(0, BROWSINGY+this.inbox.Height);
					this.browsingWindow.Size = new Size(MAXIMIZEDX, IEBrowser.BROWSINGH-this.inbox.Height);
					this.inbox.GotoCurrentEmail();
				} 
				else 
				{
					(this.browsingWindow.Document as IHTMLDocument2).write("<html><body></body></html>");
					this.inbox.Hide();
					this.browsingWindow.Location = new Point(0, IEBrowser.BROWSINGY);
					this.browsingWindow.Size = new Size(MAXIMIZEDX, IEBrowser.BROWSINGH);
				}
			}
		}

		public bool IsLocalUrl(string url) 
		{
			return (url.StartsWith("C:") || url.StartsWith("file"));
		}

		private bool IsLegalUrl(string url) 
		{
			if (IsLocalUrl(url))
				return true;
			string domainname = PrivacyGuard.PrivacyGuardUtils.IEUtil.GetDomainName(url);
			if (url.StartsWith("http"))
			{
				for (int i = 0; i < this.legalsites.Length; i++) 
					if (domainname.Equals(this.legalsites[i]))
						return true;
			}
			return false;
		}

		public Rectangle GetBrowsingWindowToScreen() 
		{
			return this.browsingWindow.RectangleToScreen(this.browsingWindow.ClientRectangle);
		}

		public void SecureStatusbar(bool secure) 
		{
			this.statusBar.Secure(secure);
		}

		public bool IsTutorUrl(string url) 
		{
			if (IEBrowser.WEBWALLETSTUDY) 
			{
				return url.EndsWith(TUTOR_SUFFIX);
			} 
			else 
			{
				return false;
			}
		}

		public void GetFocus() 
		{
			this.browsingWindow.Focus();
		}
	}
}
